Merge branch 'ak/maint-for-each-ref-no-lookup' into maint
[git/dscho.git] / git-rebase.sh
blob334629fc97c0d06e9c9cfda058bdd999810f9d55
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano.
6 USAGE='[--interactive | -i] [-v] [--force-rebase | -f] [--onto <newbase>] [<upstream>|--root] [<branch>]'
7 LONG_USAGE='git-rebase replaces <branch> with a new branch of the
8 same name. When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
13 It is possible that a merge failure will prevent this process from being
14 completely automatic. You will have to resolve any such merge failure
15 and run git rebase --continue. Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip. To restore the
17 original <branch> and remove the .git/rebase-apply working files, use the
18 command git rebase --abort instead.
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used.
23 Example: git-rebase master~1 topic
25 A---B---C topic A'\''--B'\''--C'\'' topic
26 / --> /
27 D---E---F---G master D---E---F---G master
30 SUBDIRECTORY_OK=Yes
31 OPTIONS_SPEC=
32 . git-sh-setup
33 set_reflog_action rebase
34 require_work_tree
35 cd_to_toplevel
37 OK_TO_SKIP_PRE_REBASE=
38 RESOLVEMSG="
39 When you have resolved this problem run \"git rebase --continue\".
40 If you would prefer to skip this patch, instead run \"git rebase --skip\".
41 To restore the original branch and stop rebasing run \"git rebase --abort\".
43 unset newbase
44 strategy=recursive
45 do_merge=
46 dotest="$GIT_DIR"/rebase-merge
47 prec=4
48 verbose=
49 diffstat=$(git config --bool rebase.stat)
50 git_am_opt=
51 rebase_root=
52 force_rebase=
54 continue_merge () {
55 test -n "$prev_head" || die "prev_head must be defined"
56 test -d "$dotest" || die "$dotest directory does not exist"
58 unmerged=$(git ls-files -u)
59 if test -n "$unmerged"
60 then
61 echo "You still have unmerged paths in your index"
62 echo "did you forget to use git add?"
63 die "$RESOLVEMSG"
66 cmt=`cat "$dotest/current"`
67 if ! git diff-index --quiet --ignore-submodules HEAD --
68 then
69 if ! git commit --no-verify -C "$cmt"
70 then
71 echo "Commit failed, please do not call \"git commit\""
72 echo "directly, but instead do one of the following: "
73 die "$RESOLVEMSG"
75 printf "Committed: %0${prec}d " $msgnum
76 else
77 printf "Already applied: %0${prec}d " $msgnum
79 git rev-list --pretty=oneline -1 "$cmt" | sed -e 's/^[^ ]* //'
81 prev_head=`git rev-parse HEAD^0`
82 # save the resulting commit so we can read-tree on it later
83 echo "$prev_head" > "$dotest/prev_head"
85 # onto the next patch:
86 msgnum=$(($msgnum + 1))
87 echo "$msgnum" >"$dotest/msgnum"
90 call_merge () {
91 cmt="$(cat "$dotest/cmt.$1")"
92 echo "$cmt" > "$dotest/current"
93 hd=$(git rev-parse --verify HEAD)
94 cmt_name=$(git symbolic-ref HEAD 2> /dev/null || echo HEAD)
95 msgnum=$(cat "$dotest/msgnum")
96 end=$(cat "$dotest/end")
97 eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
98 eval GITHEAD_$hd='$(cat "$dotest/onto_name")'
99 export GITHEAD_$cmt GITHEAD_$hd
100 git-merge-$strategy "$cmt^" -- "$hd" "$cmt"
101 rv=$?
102 case "$rv" in
104 unset GITHEAD_$cmt GITHEAD_$hd
105 return
108 git rerere
109 die "$RESOLVEMSG"
112 echo "Strategy: $rv $strategy failed, try another" 1>&2
113 die "$RESOLVEMSG"
116 die "Unknown exit code ($rv) from command:" \
117 "git-merge-$strategy $cmt^ -- HEAD $cmt"
119 esac
122 move_to_original_branch () {
123 test -z "$head_name" &&
124 head_name="$(cat "$dotest"/head-name)" &&
125 onto="$(cat "$dotest"/onto)" &&
126 orig_head="$(cat "$dotest"/orig-head)"
127 case "$head_name" in
128 refs/*)
129 message="rebase finished: $head_name onto $onto"
130 git update-ref -m "$message" \
131 $head_name $(git rev-parse HEAD) $orig_head &&
132 git symbolic-ref HEAD $head_name ||
133 die "Could not move back to $head_name"
135 esac
138 finish_rb_merge () {
139 move_to_original_branch
140 rm -r "$dotest"
141 echo "All done."
144 is_interactive () {
145 while test $# != 0
147 case "$1" in
148 -i|--interactive)
149 interactive_rebase=explicit
150 break
152 -p|--preserve-merges)
153 interactive_rebase=implied
155 esac
156 shift
157 done
159 if [ "$interactive_rebase" = implied ]; then
160 GIT_EDITOR=:
161 export GIT_EDITOR
164 test -n "$interactive_rebase" || test -f "$dotest"/interactive
167 run_pre_rebase_hook () {
168 if test -z "$OK_TO_SKIP_PRE_REBASE" &&
169 test -x "$GIT_DIR/hooks/pre-rebase"
170 then
171 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
172 die "The pre-rebase hook refused to rebase."
176 test -f "$GIT_DIR"/rebase-apply/applying &&
177 die 'It looks like git-am is in progress. Cannot rebase.'
179 is_interactive "$@" && exec git-rebase--interactive "$@"
181 if test $# -eq 0
182 then
183 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply || usage
184 test -d "$dotest" -o -f "$GIT_DIR"/rebase-apply/rebasing &&
185 die 'A rebase is in progress, try --continue, --skip or --abort.'
186 die "No arguments given and $GIT_DIR/rebase-apply already exists."
189 while test $# != 0
191 case "$1" in
192 --no-verify)
193 OK_TO_SKIP_PRE_REBASE=yes
195 --continue)
196 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
197 die "No rebase in progress?"
199 git diff-files --quiet --ignore-submodules || {
200 echo "You must edit all merge conflicts and then"
201 echo "mark them as resolved using git add"
202 exit 1
204 if test -d "$dotest"
205 then
206 prev_head=$(cat "$dotest/prev_head")
207 end=$(cat "$dotest/end")
208 msgnum=$(cat "$dotest/msgnum")
209 onto=$(cat "$dotest/onto")
210 continue_merge
211 while test "$msgnum" -le "$end"
213 call_merge "$msgnum"
214 continue_merge
215 done
216 finish_rb_merge
217 exit
219 head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
220 onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
221 orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
222 git am --resolved --3way --resolvemsg="$RESOLVEMSG" &&
223 move_to_original_branch
224 exit
226 --skip)
227 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
228 die "No rebase in progress?"
230 git reset --hard HEAD || exit $?
231 if test -d "$dotest"
232 then
233 git rerere clear
234 prev_head=$(cat "$dotest/prev_head")
235 end=$(cat "$dotest/end")
236 msgnum=$(cat "$dotest/msgnum")
237 msgnum=$(($msgnum + 1))
238 onto=$(cat "$dotest/onto")
239 while test "$msgnum" -le "$end"
241 call_merge "$msgnum"
242 continue_merge
243 done
244 finish_rb_merge
245 exit
247 head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
248 onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
249 orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
250 git am -3 --skip --resolvemsg="$RESOLVEMSG" &&
251 move_to_original_branch
252 exit
254 --abort)
255 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
256 die "No rebase in progress?"
258 git rerere clear
259 if test -d "$dotest"
260 then
261 move_to_original_branch
262 else
263 dotest="$GIT_DIR"/rebase-apply
264 move_to_original_branch
266 git reset --hard $(cat "$dotest/orig-head")
267 rm -r "$dotest"
268 exit
270 --onto)
271 test 2 -le "$#" || usage
272 newbase="$2"
273 shift
275 -M|-m|--m|--me|--mer|--merg|--merge)
276 do_merge=t
278 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
279 --strateg=*|--strategy=*|\
280 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
281 case "$#,$1" in
282 *,*=*)
283 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
284 1,*)
285 usage ;;
287 strategy="$2"
288 shift ;;
289 esac
290 do_merge=t
292 -n|--no-stat)
293 diffstat=
295 --stat)
296 diffstat=t
298 -v|--verbose)
299 verbose=t
300 diffstat=t
302 --whitespace=*)
303 git_am_opt="$git_am_opt $1"
304 case "$1" in
305 --whitespace=fix|--whitespace=strip)
306 force_rebase=t
308 esac
310 --committer-date-is-author-date|--ignore-date)
311 git_am_opt="$git_am_opt $1"
312 force_rebase=t
314 -C*)
315 git_am_opt="$git_am_opt $1"
317 --root)
318 rebase_root=t
320 -f|--f|--fo|--for|--forc|force|--force-r|--force-re|--force-reb|--force-reba|--force-rebas|--force-rebase)
321 force_rebase=t
324 usage
327 break
329 esac
330 shift
331 done
332 test $# -gt 2 && usage
334 # Make sure we do not have $GIT_DIR/rebase-apply
335 if test -z "$do_merge"
336 then
337 if mkdir "$GIT_DIR"/rebase-apply 2>/dev/null
338 then
339 rmdir "$GIT_DIR"/rebase-apply
340 else
341 echo >&2 '
342 It seems that I cannot create a rebase-apply directory, and
343 I wonder if you are in the middle of patch application or another
344 rebase. If that is not the case, please
345 rm -fr '"$GIT_DIR"'/rebase-apply
346 and run me again. I am stopping in case you still have something
347 valuable there.'
348 exit 1
350 else
351 if test -d "$dotest"
352 then
353 die "previous rebase directory $dotest still exists." \
354 'Try git rebase (--continue | --abort | --skip)'
358 # The tree must be really really clean.
359 if ! git update-index --ignore-submodules --refresh; then
360 die "cannot rebase: you have unstaged changes"
362 diff=$(git diff-index --cached --name-status -r --ignore-submodules HEAD --)
363 case "$diff" in
364 ?*) echo >&2 "cannot rebase: your index contains uncommitted changes"
365 echo >&2 "$diff"
366 exit 1
368 esac
370 if test -z "$rebase_root"
371 then
372 # The upstream head must be given. Make sure it is valid.
373 upstream_name="$1"
374 shift
375 upstream=`git rev-parse --verify "${upstream_name}^0"` ||
376 die "invalid upstream $upstream_name"
377 unset root_flag
378 upstream_arg="$upstream_name"
379 else
380 test -z "$newbase" && die "--root must be used with --onto"
381 unset upstream_name
382 unset upstream
383 root_flag="--root"
384 upstream_arg="$root_flag"
387 # Make sure the branch to rebase onto is valid.
388 onto_name=${newbase-"$upstream_name"}
389 onto=$(git rev-parse --verify "${onto_name}^0") || exit
391 # If a hook exists, give it a chance to interrupt
392 run_pre_rebase_hook "$upstream_arg" "$@"
394 # If the branch to rebase is given, that is the branch we will rebase
395 # $branch_name -- branch being rebased, or HEAD (already detached)
396 # $orig_head -- commit object name of tip of the branch before rebasing
397 # $head_name -- refs/heads/<that-branch> or "detached HEAD"
398 switch_to=
399 case "$#" in
401 # Is it "rebase other $branchname" or "rebase other $commit"?
402 branch_name="$1"
403 switch_to="$1"
405 if git show-ref --verify --quiet -- "refs/heads/$1" &&
406 branch=$(git rev-parse -q --verify "refs/heads/$1")
407 then
408 head_name="refs/heads/$1"
409 elif branch=$(git rev-parse -q --verify "$1")
410 then
411 head_name="detached HEAD"
412 else
413 usage
417 # Do not need to switch branches, we are already on it.
418 if branch_name=`git symbolic-ref -q HEAD`
419 then
420 head_name=$branch_name
421 branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
422 else
423 head_name="detached HEAD"
424 branch_name=HEAD ;# detached
426 branch=$(git rev-parse --verify "${branch_name}^0") || exit
428 esac
429 orig_head=$branch
431 # Now we are rebasing commits $upstream..$branch (or with --root,
432 # everything leading up to $branch) on top of $onto
434 # Check if we are already based on $onto with linear history,
435 # but this should be done only when upstream and onto are the same.
436 mb=$(git merge-base "$onto" "$branch")
437 if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
438 # linear history?
439 ! (git rev-list --parents "$onto".."$branch" | grep " .* ") > /dev/null
440 then
441 if test -z "$force_rebase"
442 then
443 # Lazily switch to the target branch if needed...
444 test -z "$switch_to" || git checkout "$switch_to"
445 echo >&2 "Current branch $branch_name is up to date."
446 exit 0
447 else
448 echo "Current branch $branch_name is up to date, rebase forced."
452 # Detach HEAD and reset the tree
453 echo "First, rewinding head to replay your work on top of it..."
454 git checkout -q "$onto^0" || die "could not detach HEAD"
455 git update-ref ORIG_HEAD $branch
457 if test -n "$diffstat"
458 then
459 if test -n "$verbose"
460 then
461 echo "Changes from $mb to $onto:"
463 # We want color (if set), but no pager
464 GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
467 # If the $onto is a proper descendant of the tip of the branch, then
468 # we just fast forwarded.
469 if test "$mb" = "$branch"
470 then
471 echo >&2 "Fast-forwarded $branch_name to $onto_name."
472 move_to_original_branch
473 exit 0
476 if test -n "$rebase_root"
477 then
478 revisions="$onto..$orig_head"
479 else
480 revisions="$upstream..$orig_head"
483 if test -z "$do_merge"
484 then
485 git format-patch -k --stdout --full-index --ignore-if-in-upstream \
486 $root_flag "$revisions" |
487 git am $git_am_opt --rebasing --resolvemsg="$RESOLVEMSG" &&
488 move_to_original_branch
489 ret=$?
490 test 0 != $ret -a -d "$GIT_DIR"/rebase-apply &&
491 echo $head_name > "$GIT_DIR"/rebase-apply/head-name &&
492 echo $onto > "$GIT_DIR"/rebase-apply/onto &&
493 echo $orig_head > "$GIT_DIR"/rebase-apply/orig-head
494 exit $ret
497 # start doing a rebase with git-merge
498 # this is rename-aware if the recursive (default) strategy is used
500 mkdir -p "$dotest"
501 echo "$onto" > "$dotest/onto"
502 echo "$onto_name" > "$dotest/onto_name"
503 prev_head=$orig_head
504 echo "$prev_head" > "$dotest/prev_head"
505 echo "$orig_head" > "$dotest/orig-head"
506 echo "$head_name" > "$dotest/head-name"
508 msgnum=0
509 for cmt in `git rev-list --reverse --no-merges "$revisions"`
511 msgnum=$(($msgnum + 1))
512 echo "$cmt" > "$dotest/cmt.$msgnum"
513 done
515 echo 1 >"$dotest/msgnum"
516 echo $msgnum >"$dotest/end"
518 end=$msgnum
519 msgnum=1
521 while test "$msgnum" -le "$end"
523 call_merge "$msgnum"
524 continue_merge
525 done
527 finish_rb_merge